diff --git nRF5_SDK_15.3.0_59ac345/components/boards/pca10056.h nRF5_SDK_15.3.0_66869dd/components/boards/pca10056.h
index ac43159..17698a8 100644
--- nRF5_SDK_15.3.0_59ac345/components/boards/pca10056.h
+++ nRF5_SDK_15.3.0_66869dd/components/boards/pca10056.h
@@ -90,6 +90,8 @@ extern "C" {
 #define RTS_PIN_NUMBER 5
 #define HWFC           true
 
+#define BSP_SELF_PINRESET_PIN NRF_GPIO_PIN_MAP(0,24)
+
 #define BSP_QSPI_SCK_PIN   19
 #define BSP_QSPI_CSN_PIN   17
 #define BSP_QSPI_IO0_PIN   20
diff --git nRF5_SDK_15.3.0_59ac345/components/libraries/bootloader/dfu/nrf_dfu_trigger_usb.c nRF5_SDK_15.3.0_66869dd/components/libraries/bootloader/dfu/nrf_dfu_trigger_usb.c
--- nRF5_SDK_15.3.0_59ac345/components/libraries/bootloader/dfu/nrf_dfu_trigger_usb.c
+++ nRF5_SDK_15.3.0_66869dd/components/libraries/bootloader/dfu/nrf_dfu_trigger_usb.c
@@ -50,10 +50,6 @@
 #include "nrf_log.h"
 NRF_LOG_MODULE_REGISTER();
 
-#ifndef BSP_SELF_PINRESET_PIN
-#error "This module is intended to be used with boards that have the GP pin shortened with the RESET pin."
-#endif
-
 /**
  * @brief Enable power USB detection.
  *
@@ -71,6 +67,7 @@ NRF_LOG_MODULE_REGISTER();
 
 static uint8_t                                m_version_string[] = APP_NAME " " VERSION_STRING; ///< Human-readable version string.
 static app_usbd_nrf_dfu_trigger_nordic_info_t m_dfu_info;                                       ///< Struct with various information about the current firmware.
+static uint32_t m_pin_reset;
 
 static void dfu_trigger_evt_handler(app_usbd_class_inst_t        const *  p_inst,
                                     app_usbd_nrf_dfu_trigger_user_event_t event)
@@ -82,8 +79,8 @@ static void dfu_trigger_evt_handler(app_usbd_class_inst_t        const *  p_inst
         case APP_USBD_NRF_DFU_TRIGGER_USER_EVT_DETACH:
             NRF_LOG_INFO("DFU Detach request received. Triggering a pin reset.");
             NRF_LOG_FINAL_FLUSH();
-            nrf_gpio_cfg_output(BSP_SELF_PINRESET_PIN);
-            nrf_gpio_pin_clear(BSP_SELF_PINRESET_PIN);
+            nrf_gpio_cfg_output(m_pin_reset);
+            nrf_gpio_pin_clear(m_pin_reset);
             break;
         default:
             break;
@@ -173,7 +170,7 @@ static void usbd_evt_handler(app_usbd_internal_evt_t const * const p_event)
 }
 #endif
 
-ret_code_t nrf_dfu_trigger_usb_init(void)
+ret_code_t nrf_dfu_trigger_usb_init(uint32_t pin_reset)
 {
     ret_code_t  ret;
     static bool initialized = false;
@@ -183,6 +180,7 @@ ret_code_t nrf_dfu_trigger_usb_init(void)
         return NRF_SUCCESS;
     }
 
+    m_pin_reset               = pin_reset;
     m_dfu_info.wAddress       = CODE_START;
     m_dfu_info.wFirmwareSize  = CODE_SIZE;
     m_dfu_info.wVersionMajor  = APP_VERSION_MAJOR;
diff --git nRF5_SDK_15.3.0_59ac345/components/libraries/bootloader/dfu/nrf_dfu_trigger_usb.h nRF5_SDK_15.3.0_66869dd/components/libraries/bootloader/dfu/nrf_dfu_trigger_usb.h
--- nRF5_SDK_15.3.0_59ac345/components/libraries/bootloader/dfu/nrf_dfu_trigger_usb.h
+++ nRF5_SDK_15.3.0_66869dd/components/libraries/bootloader/dfu/nrf_dfu_trigger_usb.h
@@ -63,11 +63,12 @@
  *
  * @note  If @ref APP_USBD_CONFIG_EVENT_QUEUE_ENABLE is on (1), USB events must be handled manually.
  *        See @ref app_usbd_event_queue_process.
+ * @param pin_reset Pin which is shortened with the actual pin reset.
  *
  * @retval NRF_SUCCESS  On successful initialization.
  * @return An error code on failure, for example if called at a wrong time.
  */
-ret_code_t nrf_dfu_trigger_usb_init(void);
+ret_code_t nrf_dfu_trigger_usb_init(uint32_t pin_reset);
 
 /** @} */
 
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/application/codecs/ble/middleware/app_mw_ble_gap.c nRF5_SDK_15.3.0_66869dd/components/serialization/application/codecs/ble/middleware/app_mw_ble_gap.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/application/codecs/ble/middleware/app_mw_ble_gap.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/application/codecs/ble/middleware/app_mw_ble_gap.c
@@ -1907,8 +1907,8 @@ static uint32_t gap_adv_set_configure_rsp_dec(const uint8_t * p_buffer, uint16_t
 
     if (result_code != NRF_SUCCESS)
     {
-    	app_ble_gap_adv_buf_addr_unregister(mp_out_params[0], false);
-    	app_ble_gap_adv_buf_addr_unregister(mp_out_params[1], false);
+        app_ble_gap_adv_buf_addr_unregister(mp_out_params[0], false);
+        app_ble_gap_adv_buf_addr_unregister(mp_out_params[1], false);
     }
 
     //@note: Should never fail.
@@ -1928,7 +1928,7 @@ uint32_t _sd_ble_gap_adv_set_configure(uint8_t *p_adv_handle,
 {
     uint8_t * p_buffer;
     uint32_t  buffer_length = 0;
-
+    uint32_t err;
     tx_buf_alloc(&p_buffer, (uint16_t *)&buffer_length);
 
     if (p_adv_handle)
@@ -1948,9 +1948,16 @@ uint32_t _sd_ble_gap_adv_set_configure(uint8_t *p_adv_handle,
     APP_ERROR_CHECK(err_code);
 
     //@note: Increment buffer length as internally managed packet type field must be included.
-    return ser_sd_transport_cmd_write(p_buffer,
+    err = ser_sd_transport_cmd_write(p_buffer,
                                       (++buffer_length),
                                       gap_adv_set_configure_rsp_dec);
+
+    if (err == NRF_SUCCESS && p_adv_data)
+    {
+        app_ble_gap_set_adv_data_set(*p_adv_handle, mp_out_params[0], mp_out_params[1]);
+    }
+
+    return err;
 }
 
 #ifndef S112
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/application/codecs/ble/serializers/app_ble_gap_sec_keys.c nRF5_SDK_15.3.0_66869dd/components/serialization/application/codecs/ble/serializers/app_ble_gap_sec_keys.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/application/codecs/ble/serializers/app_ble_gap_sec_keys.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/application/codecs/ble/serializers/app_ble_gap_sec_keys.c
@@ -55,21 +55,52 @@ typedef struct {
 
 static adv_set_t m_adv_sets[4]; //todo configurable number of adv sets.
 
+typedef struct
+{
+    uint8_t adv_handle;
+    uint8_t * buf1;
+    uint8_t * buf2;
+} adv_set_data_t;
+
+typedef enum {
+    BLE_DATA_BUF_FREE,
+    BLE_DATA_BUF_IN_USE,
+    BLE_DATA_BUF_LAST_DIRTY,
+} ble_data_buf_state_t;
+
+static adv_set_data_t adv_set_data[BLE_GAP_ADV_SET_COUNT_MAX];
+
 static ble_data_t m_scan_data = {0};
 static int scan_data_id;
 #endif
 ser_ble_gap_app_keyset_t m_app_keys_table[SER_MAX_CONNECTIONS];
 
 #if NRF_SD_BLE_API_VERSION >= 6
-static void *m_ble_gap_adv_buf_addr_storage[8];
+
+typedef struct
+{
+    ble_data_buf_state_t state;
+    uint32_t id;
+    void *buf;
+} ble_data_item_t;
+
+ble_data_item_t m_ble_data_pool[8];
+
 #endif
 
 void app_ble_gap_sec_keys_init(void)
 {
 #if NRF_SD_BLE_API_VERSION >= 6
-    memset(m_ble_gap_adv_buf_addr_storage, 0, sizeof(m_ble_gap_adv_buf_addr_storage));
+    uint32_t i;
+
+    memset(m_ble_data_pool, 0, sizeof(m_ble_data_pool));
     memset(&m_scan_data, 0, sizeof(m_scan_data));
     memset(m_adv_sets, 0, sizeof(m_adv_sets));
+    for (i = 0; i < 8; i++)
+    {
+        m_ble_data_pool[i].state = BLE_DATA_BUF_FREE;
+        m_ble_data_pool[i].id = 0;
+    }
 #endif
     memset(m_app_keys_table, 0, sizeof(m_app_keys_table));
 }
@@ -140,12 +171,13 @@ int app_ble_gap_adv_buf_register(void * p_buf)
         return 0;
     }
 
-    for (i = 0; i < ARRAY_SIZE(m_ble_gap_adv_buf_addr_storage); i++)
+    for (i = 0; i < ARRAY_SIZE(m_ble_data_pool); i++)
     {
-        if ((m_ble_gap_adv_buf_addr_storage[i] == NULL) ||
-            (m_ble_gap_adv_buf_addr_storage[i] == p_buf))
+        if (m_ble_data_pool[i].state == BLE_DATA_BUF_FREE)
         {
-            m_ble_gap_adv_buf_addr_storage[i] = p_buf;
+            m_ble_data_pool[i].buf = p_buf;
+            m_ble_data_pool[i].id = i + 1;
+            m_ble_data_pool[i].state = BLE_DATA_BUF_IN_USE;
             return i+1;
         }
     }
@@ -161,10 +193,9 @@ void *app_ble_gap_adv_buf_unregister(int id, bool event_context)
         return NULL;
     }
 
-    void * ret = m_ble_gap_adv_buf_addr_storage[id-1];
-    m_ble_gap_adv_buf_addr_storage[id-1] = NULL;
+    m_ble_data_pool[id].state = BLE_DATA_BUF_FREE;
 
-    return ret;
+    return m_ble_data_pool[id].id;
 }
 
 void app_ble_gap_adv_buf_addr_unregister(void * p_buf, bool event_context)
@@ -177,22 +208,24 @@ void app_ble_gap_adv_buf_addr_unregister(void * p_buf, bool event_context)
         return;
     }
 
-    for (i = 0; i < ARRAY_SIZE(m_ble_gap_adv_buf_addr_storage); i++)
+    for (i = 0; i < ARRAY_SIZE(m_ble_data_pool); i++)
     {
-        if (m_ble_gap_adv_buf_addr_storage[i] == p_buf)
+        if (m_ble_data_pool[i].buf == p_buf && (m_ble_data_pool[i].state == BLE_DATA_BUF_IN_USE))
         {
-            m_ble_gap_adv_buf_addr_storage[i] = NULL;
+            m_ble_data_pool[id].state = BLE_DATA_BUF_FREE;
+            m_ble_data_pool[id].buf = 0;
         }
     }
 }
 
 void app_ble_gap_scan_data_set(uint8_t * p_scan_data)
 {
+
     uint32_t i;
 
-    for (i = 0; i < ARRAY_SIZE(m_ble_gap_adv_buf_addr_storage); i++)
+    for (i = 0; i < ARRAY_SIZE(m_ble_data_pool); i++)
     {
-        if (m_ble_gap_adv_buf_addr_storage[i] == p_scan_data)
+        if (m_ble_data_pool[i].buf == p_scan_data)
         {
             scan_data_id = i+1;
             return;
@@ -213,4 +246,47 @@ void app_ble_gap_scan_data_unset(bool free)
     }
 }
 
+static void app_ble_gap_ble_data_mark_dirty(uint8_t * p_data)
+{
+    uint32_t i;
+
+    if (p_data)
+    {
+        for (i = 0; i < ARRAY_SIZE(m_ble_data_pool); i++)
+        {
+            if (m_ble_data_pool[i].buf == p_data)
+            {
+                m_ble_data_pool[i].state = BLE_DATA_BUF_LAST_DIRTY;
+            }
+        }
+    }
+}
+static void app_ble_gap_ble_adv_data_mark_dirty(uint8_t * p_data1, uint8_t *p_data2)
+{
+    uint32_t i;
+
+    /* First find if given id already allocated the buffer. */
+    for (i = 0; i < ARRAY_SIZE(m_ble_data_pool); i++)
+    {
+        if (m_ble_data_pool[i].state == BLE_DATA_BUF_LAST_DIRTY)
+        {
+            app_ble_gap_adv_buf_unregister(i+1);
+        }
+    }
+
+    app_ble_gap_ble_data_mark_dirty(p_data1);
+    app_ble_gap_ble_data_mark_dirty(p_data2);
+}
+
+void app_ble_gap_set_adv_data_set(uint8_t adv_handle, uint8_t * buf1, uint8_t * buf2)
+{
+    if (adv_handle == BLE_GAP_ADV_SET_HANDLE_NOT_SET)
+    {
+        adv_handle = BLE_GAP_ADV_SET_COUNT_MAX - 1;
+    }
+    app_ble_gap_ble_adv_data_mark_dirty(adv_set_data[adv_handle].buf1, adv_set_data[adv_handle].buf2);
+
+    adv_set_data[adv_handle].buf1 = buf1;
+    adv_set_data[adv_handle].buf2 = buf2;
+}
 #endif /* NRF_SD_BLE_API_VERSION >= 6 */
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/application/codecs/ble/serializers/app_ble_gap_sec_keys.h nRF5_SDK_15.3.0_66869dd/components/serialization/application/codecs/ble/serializers/app_ble_gap_sec_keys.h
--- nRF5_SDK_15.3.0_59ac345/components/serialization/application/codecs/ble/serializers/app_ble_gap_sec_keys.h
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/application/codecs/ble/serializers/app_ble_gap_sec_keys.h
@@ -112,6 +112,7 @@ void app_ble_gap_adv_buf_addr_unregister(void * p_buf, bool event_context);
 void app_ble_gap_scan_data_set(uint8_t * p_scan_data);
 void app_ble_gap_scan_data_unset(bool free);
 
+void app_ble_gap_set_adv_data_set(uint8_t adv_handle, uint8_t * buf1, uint8_t * buf2);
 #endif
 #ifdef __cplusplus
 }
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/application/codecs/ble/serializers/ble_gap_app.c nRF5_SDK_15.3.0_66869dd/components/serialization/application/codecs/ble/serializers/ble_gap_app.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/application/codecs/ble/serializers/ble_gap_app.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/application/codecs/ble/serializers/ble_gap_app.c
@@ -641,7 +641,7 @@ uint32_t ble_gap_scan_start_req_enc(ble_gap_scan_params_t const *  p_scan_params
     SER_REQ_ENC_BEGIN(SD_BLE_GAP_SCAN_START);
     SER_PUSH_COND(p_scan_params, ble_gap_scan_params_t_enc);
 #if defined(NRF_SD_BLE_API_VERSION) && NRF_SD_BLE_API_VERSION > 5
-    SER_PUSH_COND(p_adv_report_buffer, ble_data_t_enc);
+    SER_PUSH_COND(p_adv_report_buffer, ble_data_t_empty_enc);
 #endif
     SER_REQ_ENC_END;
 }
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/application/codecs/ble/serializers/ble_gap_evt_app.c nRF5_SDK_15.3.0_66869dd/components/serialization/application/codecs/ble/serializers/ble_gap_evt_app.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/application/codecs/ble/serializers/ble_gap_evt_app.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/application/codecs/ble/serializers/ble_gap_evt_app.c
@@ -323,7 +323,7 @@ uint32_t ble_gap_evt_timeout_dec(uint8_t const * const p_buf,
 #if defined(NRF_SD_BLE_API_VERSION) && (NRF_SD_BLE_API_VERSION > 5) && !defined(S112)
     if (p_event->evt.gap_evt.params.timeout.src == BLE_GAP_TIMEOUT_SRC_SCAN)
     {
-        SER_PULL_FIELD(&p_event->evt.gap_evt.params.timeout.params.adv_report_buffer, ble_data_t_dec);
+        SER_PULL_FIELD(&p_event->evt.gap_evt.params.timeout.params.adv_report_buffer, ble_data_t_empty_dec);
     }
 #endif
     SER_EVT_DEC_END;
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/common/ser_config.h nRF5_SDK_15.3.0_66869dd/components/serialization/common/ser_config.h
--- nRF5_SDK_15.3.0_59ac345/components/serialization/common/ser_config.h
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/common/ser_config.h
@@ -70,8 +70,8 @@ extern "C" {
 #define SER_HAL_TRANSPORT_APP_TO_CONN_MAX_PKT_SIZE    (128UL)
 #define SER_HAL_TRANSPORT_CONN_TO_APP_MAX_PKT_SIZE    (128UL)
 #else
-#define SER_HAL_TRANSPORT_APP_TO_CONN_MAX_PKT_SIZE    (512UL)
-#define SER_HAL_TRANSPORT_CONN_TO_APP_MAX_PKT_SIZE    (512UL)
+#define SER_HAL_TRANSPORT_APP_TO_CONN_MAX_PKT_SIZE    (768UL)
+#define SER_HAL_TRANSPORT_CONN_TO_APP_MAX_PKT_SIZE    (768UL)
 #endif
 
 #define SER_HAL_TRANSPORT_MAX_PKT_SIZE ((SER_HAL_TRANSPORT_APP_TO_CONN_MAX_PKT_SIZE) >= \
@@ -104,7 +104,7 @@ extern "C" {
 
 /** UART transmission parameters */
 #define SER_PHY_UART_FLOW_CTRL          NRF_UART_HWFC_ENABLED
-#define SER_PHY_UART_PARITY             NRF_UART_PARITY_INCLUDED
+#define SER_PHY_UART_PARITY             NRF_UART_PARITY_EXCLUDED
 #define SER_PHY_UART_BAUDRATE_VAL       1000000
 
 #define SER_PHY_UART_BAUDRATE CONCAT_2(NRF_UART_BAUDRATE_,SER_PHY_UART_BAUDRATE_VAL)
@@ -122,7 +122,8 @@ extern "C" {
 #ifndef SER_MAX_ADV_DATA
 #define SER_MAX_ADV_DATA 256
 #endif
- 
+
+#define HCI_LINK_CONTROL
 #ifdef __cplusplus
 }
 #endif
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/common/struct_ser/ble/ble_gap_struct_serialization.c nRF5_SDK_15.3.0_66869dd/components/serialization/common/struct_ser/ble/ble_gap_struct_serialization.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/common/struct_ser/ble/ble_gap_struct_serialization.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/common/struct_ser/ble/ble_gap_struct_serialization.c
@@ -454,7 +454,7 @@ uint32_t ble_gap_evt_connected_t_enc(void const * const p_void_struct,
     SER_PUSH_FIELD(&p_struct->conn_params, ble_gap_conn_params_t_enc);
 #if defined(NRF_SD_BLE_API_VERSION) && NRF_SD_BLE_API_VERSION > 5
     SER_PUSH_uint8(&p_struct->adv_handle);
-    SER_PUSH_FIELD(&p_struct->adv_data, ble_gap_adv_data_t_enc);
+    SER_PUSH_FIELD(&p_struct->adv_data, ble_gap_adv_data_t_empty_enc);
 #endif
 
     SER_STRUCT_ENC_END;
@@ -472,7 +472,7 @@ uint32_t ble_gap_evt_connected_t_dec(uint8_t const * const p_buf,
     SER_PULL_FIELD(&p_struct->conn_params, ble_gap_conn_params_t_dec);
 #if defined(NRF_SD_BLE_API_VERSION) && NRF_SD_BLE_API_VERSION > 5
     SER_PULL_uint8(&p_struct->adv_handle);
-    SER_PULL_FIELD(&p_struct->adv_data, ble_gap_adv_data_t_dec);
+    SER_PULL_FIELD(&p_struct->adv_data, ble_gap_adv_data_t_empty_dec);
 #endif
 
     SER_STRUCT_DEC_END;
@@ -1709,6 +1709,32 @@ uint32_t ble_gap_adv_data_t_dec(uint8_t const * const p_buf,
     SER_STRUCT_DEC_END;
 }
 
+uint32_t ble_gap_adv_data_t_empty_enc(void const * const p_void_struct,
+                                uint8_t * const    p_buf,
+                                uint32_t           buf_len,
+                                uint32_t * const   p_index)
+{
+    SER_STRUCT_ENC_BEGIN(ble_gap_adv_data_t);
+
+    SER_PUSH_FIELD(&p_struct->adv_data, ble_data_t_empty_enc);
+    SER_PUSH_FIELD(&p_struct->scan_rsp_data, ble_data_t_empty_enc);
+
+    SER_STRUCT_ENC_END;
+}
+
+uint32_t ble_gap_adv_data_t_empty_dec(uint8_t const * const p_buf,
+                                uint32_t              buf_len,
+                                uint32_t * const      p_index,
+                                void * const          p_void_struct)
+{
+    SER_STRUCT_DEC_BEGIN(ble_gap_adv_data_t);
+
+    SER_PULL_FIELD(&p_struct->adv_data, ble_data_t_empty_dec);
+    SER_PULL_FIELD(&p_struct->scan_rsp_data, ble_data_t_empty_dec);
+
+    SER_STRUCT_DEC_END;
+}
+
 uint32_t ble_gap_evt_adv_set_terminated_t_enc(void const * const p_void_struct,
                                 uint8_t * const    p_buf,
                                 uint32_t           buf_len,
@@ -1719,8 +1745,7 @@ uint32_t ble_gap_evt_adv_set_terminated_t_enc(void const * const p_void_struct,
     SER_PUSH_uint8(&p_struct->reason);
     SER_PUSH_uint8(&p_struct->adv_handle);
     SER_PUSH_uint8(&p_struct->num_completed_adv_events);
-
-    SER_PUSH_FIELD(&p_struct->adv_data, ble_gap_adv_data_t_enc);
+    SER_PUSH_FIELD(&p_struct->adv_data, ble_gap_adv_data_t_empty_enc);
 
     SER_STRUCT_ENC_END;
 }
@@ -1736,7 +1761,7 @@ uint32_t ble_gap_evt_adv_set_terminated_t_dec(uint8_t const * const p_buf,
     SER_PULL_uint8(&p_struct->adv_handle);
     SER_PULL_uint8(&p_struct->num_completed_adv_events);
 
-    SER_PULL_FIELD(&p_struct->adv_data, ble_gap_adv_data_t_dec);
+    SER_PULL_FIELD(&p_struct->adv_data, ble_gap_adv_data_t_empty_dec);
 
     SER_STRUCT_DEC_END;
 }
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/common/struct_ser/ble/ble_gap_struct_serialization.h nRF5_SDK_15.3.0_66869dd/components/serialization/common/struct_ser/ble/ble_gap_struct_serialization.h
--- nRF5_SDK_15.3.0_59ac345/components/serialization/common/struct_ser/ble/ble_gap_struct_serialization.h
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/common/struct_ser/ble/ble_gap_struct_serialization.h
@@ -594,6 +594,16 @@ uint32_t ble_gap_adv_data_t_dec(uint8_t const * const p_buf,
                                 uint32_t * const      p_index,
                                 void * const          p_void_struct);
 
+uint32_t ble_gap_adv_data_t_empty_enc(void const * const p_void_struct,
+                                uint8_t * const    p_buf,
+                                uint32_t           buf_len,
+                                uint32_t * const   p_index);
+
+uint32_t ble_gap_adv_data_t_empty_dec(uint8_t const * const p_buf,
+                                uint32_t              buf_len,
+                                uint32_t * const      p_index,
+                                void * const          p_void_struct);
+
 uint32_t ble_gap_evt_adv_set_terminated_t_enc(void const * const p_void_struct,
                                 uint8_t * const    p_buf,
                                 uint32_t           buf_len,
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/common/struct_ser/ble/ble_struct_serialization.c nRF5_SDK_15.3.0_66869dd/components/serialization/common/struct_ser/ble/ble_struct_serialization.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/common/struct_ser/ble/ble_struct_serialization.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/common/struct_ser/ble/ble_struct_serialization.c
@@ -47,6 +47,11 @@
 #include "ble.h"
 #include "cond_field_serialization.h"
 #include "ser_config.h"
+#ifdef SER_CONNECTIVITY
+#include "conn_ble_gap_sec_keys.h"
+#else
+#include "app_ble_gap_sec_keys.h"
+#endif
 #include <string.h>
 
 #if NRF_SD_BLE_API_VERSION > 5
@@ -542,4 +547,56 @@ uint32_t ble_data_t_dec(uint8_t const * const p_buf,
 
     SER_STRUCT_DEC_END;
 }
+
+uint32_t ble_data_t_empty_enc(void const * const p_void_struct,
+                        uint8_t * const    p_buf,
+                        uint32_t           buf_len,
+                        uint32_t * const   p_index)
+{
+    SER_STRUCT_ENC_BEGIN(ble_data_t);
+
+    uint32_t buf_id = 0;
+#if NRF_SD_BLE_API_VERSION > 5
+#if defined(SER_CONNECTIVITY)
+    buf_id = conn_ble_gap_ble_data_buf_free(p_struct->p_data);
+#else
+    buf_id = app_ble_gap_adv_buf_register(p_struct->p_data);
+    SER_ASSERT(buf_id >= 0, NRF_ERROR_NO_MEM);
+#endif
+#endif
+    SER_PUSH_uint32(&buf_id);
+    SER_PUSH_uint16(&p_struct->len);
+
+    SER_STRUCT_ENC_END;
+}
+
+uint32_t ble_data_t_empty_dec(uint8_t const * const p_buf,
+                        uint32_t              buf_len,
+                        uint32_t * const      p_index,
+                        void * const          p_void_struct)
+{
+    SER_STRUCT_DEC_BEGIN(ble_data_t);
+
+    uint32_t buf_id;
+    SER_PULL_uint32(&buf_id);
+    p_struct->len = SER_MAX_ADV_DATA;
+#if NRF_SD_BLE_API_VERSION > 5
+#if defined(SER_CONNECTIVITY)
+    if (buf_id && (p_struct->p_data == NULL))
+    {
+        p_struct->p_data = conn_ble_gap_ble_data_buf_alloc(buf_id);
+    }
+#else
+    p_struct->p_data = app_ble_gap_adv_buf_unregister(buf_id, true);
+#endif
+#endif
+    SER_PULL_uint16(&p_struct->len);
+
+    if (p_struct->p_data == NULL)
+    {
+        p_struct->len = 0;
+    }
+
+    SER_STRUCT_DEC_END;
+}
 #endif
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/common/struct_ser/ble/ble_struct_serialization.h nRF5_SDK_15.3.0_66869dd/components/serialization/common/struct_ser/ble/ble_struct_serialization.h
--- nRF5_SDK_15.3.0_59ac345/components/serialization/common/struct_ser/ble/ble_struct_serialization.h
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/common/struct_ser/ble/ble_struct_serialization.h
@@ -209,6 +209,16 @@ uint32_t ble_data_t_dec(uint8_t const * const p_buf,
                         uint32_t              buf_len,
                         uint32_t * const      p_index,
                         void * const          p_void_struct);
+
+uint32_t ble_data_t_empty_enc(void const * const p_void_struct,
+                        uint8_t * const    p_buf,
+                        uint32_t           buf_len,
+                        uint32_t * const   p_index);
+
+uint32_t ble_data_t_empty_dec(uint8_t const * const p_buf,
+                        uint32_t              buf_len,
+                        uint32_t * const      p_index,
+                        void * const          p_void_struct);
 #endif
 #ifdef __cplusplus
 }
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/common/transport/ser_phy/config/ser_phy_config_conn.h nRF5_SDK_15.3.0_66869dd/components/serialization/common/transport/ser_phy/config/ser_phy_config_conn.h
--- nRF5_SDK_15.3.0_59ac345/components/serialization/common/transport/ser_phy/config/ser_phy_config_conn.h
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/common/transport/ser_phy/config/ser_phy_config_conn.h
@@ -69,10 +69,10 @@ extern "C" {
 /* UART configuration */
 #define UART_IRQ_PRIORITY                       APP_IRQ_PRIORITY_LOWEST
 
-#define SER_PHY_UART_RX                         SER_CON_RX_PIN
-#define SER_PHY_UART_TX                         SER_CON_TX_PIN
-#define SER_PHY_UART_CTS                        SER_CON_CTS_PIN
-#define SER_PHY_UART_RTS                        SER_CON_RTS_PIN
+#define SER_PHY_UART_RX                         RX_PIN_NUMBER//SER_CON_RX_PIN
+#define SER_PHY_UART_TX                         TX_PIN_NUMBER//SER_CON_TX_PIN
+#define SER_PHY_UART_CTS                        CTS_PIN_NUMBER//SER_CON_CTS_PIN
+#define SER_PHY_UART_RTS                        RTS_PIN_NUMBER//SER_CON_RTS_PIN
 
 
 #ifdef __cplusplus
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/common/transport/ser_phy/ser_phy_hci_slip_cdc.c nRF5_SDK_15.3.0_66869dd/components/serialization/common/transport/ser_phy/ser_phy_hci_slip_cdc.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/common/transport/ser_phy/ser_phy_hci_slip_cdc.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/common/transport/ser_phy/ser_phy_hci_slip_cdc.c
@@ -67,10 +67,10 @@ NRF_LOG_MODULE_REGISTER();
 static void cdc_acm_user_ev_handler(app_usbd_class_inst_t const * p_inst,
                                     app_usbd_cdc_acm_user_event_t event);
 
-#define CDC_ACM_COMM_INTERFACE  0
+#define CDC_ACM_COMM_INTERFACE  1
 #define CDC_ACM_COMM_EPIN       NRF_DRV_USBD_EPIN2
 
-#define CDC_ACM_DATA_INTERFACE  1
+#define CDC_ACM_DATA_INTERFACE  2
 #define CDC_ACM_DATA_EPIN       NRF_DRV_USBD_EPIN1
 #define CDC_ACM_DATA_EPOUT      NRF_DRV_USBD_EPOUT1
 
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/codecs/ble/middleware/conn_mw_ble_gap.c nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/codecs/ble/middleware/conn_mw_ble_gap.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/codecs/ble/middleware/conn_mw_ble_gap.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/codecs/ble/middleware/conn_mw_ble_gap.c
@@ -1249,6 +1249,12 @@ uint32_t conn_mw_ble_gap_adv_set_configure(uint8_t const * const p_rx_buf,
        (void)conn_ble_gap_ble_data_buf_free(p_adv_data->adv_data.p_data);
        (void)conn_ble_gap_ble_data_buf_free(p_adv_data->scan_rsp_data.p_data);
    }
+   else
+   {
+       conn_ble_gap_set_adv_data_set(*p_adv_handle,
+                                     p_adv_data->adv_data.p_data,
+                                     p_adv_data->scan_rsp_data.p_data);
+   }
 
    err_code = ble_gap_adv_set_configure_rsp_enc(sd_err_code, p_tx_buf, p_tx_buf_len, p_adv_data, p_adv_handle);
    SER_ASSERT(err_code == NRF_SUCCESS, err_code);
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/codecs/ble/serializers/ble_gap_conn.c nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/codecs/ble/serializers/ble_gap_conn.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/codecs/ble/serializers/ble_gap_conn.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/codecs/ble/serializers/ble_gap_conn.c
@@ -664,7 +664,7 @@ uint32_t ble_gap_scan_start_req_dec(uint8_t const * const     p_buf,
 
     SER_PULL_COND(pp_scan_params, ble_gap_scan_params_t_dec);
 #if defined(NRF_SD_BLE_API_VERSION) && NRF_SD_BLE_API_VERSION > 5
-    SER_PULL_COND(pp_adv_report_buffer, ble_data_t_dec);
+    SER_PULL_COND(pp_adv_report_buffer, ble_data_t_empty_dec);
 #endif
 
     SER_REQ_DEC_END;
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/codecs/ble/serializers/ble_gap_evt_conn.c nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/codecs/ble/serializers/ble_gap_evt_conn.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/codecs/ble/serializers/ble_gap_evt_conn.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/codecs/ble/serializers/ble_gap_evt_conn.c
@@ -318,7 +318,7 @@ uint32_t ble_gap_evt_timeout_enc(ble_evt_t const * const p_event,
 #if defined(NRF_SD_BLE_API_VERSION) && NRF_SD_BLE_API_VERSION > 5 && !defined(S112)
     if (p_event->evt.gap_evt.params.timeout.src == BLE_GAP_TIMEOUT_SRC_SCAN)
     {
-        SER_PUSH_FIELD(&p_event->evt.gap_evt.params.timeout.params.adv_report_buffer, ble_data_t_enc);
+        SER_PUSH_FIELD(&p_event->evt.gap_evt.params.timeout.params.adv_report_buffer, ble_data_t_empty_enc);
     }
 #endif
     SER_EVT_ENC_END;
